## ants 2.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.5)
cmake_policy(VERSION 2.8.5)

set(LOCAL_PROJECT_NAME ANTS)
INCLUDE(InstallRequiredSystemLibraries)
## NOTE THERE SHOULD BE NO PROJECT STATEMENT HERE!
## This file acts as a simple switch to initiate
## two completely independant CMake build environments.

#-----------------------------------------------------------------------------
# Superbuild Option - Enabled by default
#                   Phase I:  ${LOCAL_PROJECT_NAME}_SUPERBUILD is set to ON, and the
#                             supporting packages defined in "SuperBuild.cmake"
#                             are built.  The last package in "SuperBuild.cmake"
#                             to be built is a recursive call to this
#                             file with ${LOCAL_PROJECT_NAME}_SUPERBUILD explicitly
#                             set to "OFF" to initiate Phase II
#
#                   Phase II: Build the ${LOCAL_PROJECT_NAME}, referencing the support
#                             packages built in Phase I.
#-----------------------------------------------------------------------------
option(${LOCAL_PROJECT_NAME}_SUPERBUILD "Build ${LOCAL_PROJECT_NAME} and the projects it depends on via SuperBuild.cmake." ON)
mark_as_advanced(${LOCAL_PROJECT_NAME}_SUPERBUILD)

option(${LOCAL_PROJECT_NAME}_USE_QT "Find and use Qt with VTK to build GUI Tools" OFF)
mark_as_advanced(${LOCAL_PROJECT_NAME}_USE_QT)

option(${LOCAL_PROJECT_NAME}_INSTALL_DEVELOPMENT "Install development support include and libraries for external packages." OFF)
mark_as_advanced(${LOCAL_PROJECT_NAME}_INSTALL_DEVELOPMENT)

set(CPACK_PACKAGE_NAME "ANTs")
set(CPACK_PACKAGE_VENDOR "CMake.org")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "ANTs - Advanced Normalization Tools")
set(CPACK_PACKAGE_VERSION "1.9.v4")
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "9")
set(CPACK_PACKAGE_VERSION_PATCH "v4")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "ANTS_Install")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.txt")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "ANTs - robust image registration, segmentation and more")
set(CPACK_RESOURCE_FILE_LICENSE  "${CMAKE_CURRENT_SOURCE_DIR}/ANTSCopyright.txt")
set(CPACK_RESOURCE_FILE_README "${CMAKE_CURRENT_SOURCE_DIR}/README.txt")
#-----------------------------------------------------------------------------
# Superbuild script
#-----------------------------------------------------------------------------
if(${LOCAL_PROJECT_NAME}_SUPERBUILD)
  project(SuperBuild_${LOCAL_PROJECT_NAME})
  include("${CMAKE_CURRENT_SOURCE_DIR}/SuperBuild.cmake")
  include(CPack)   # This must always be last!
  return()
else()
  project(${LOCAL_PROJECT_NAME})
  include("${CMAKE_CURRENT_SOURCE_DIR}/${LOCAL_PROJECT_NAME}.cmake")
  include(CPack)   # This must always be last!
  return()
endif()

message(FATAL_ERROR "You should never reach this point !")

=== BuildScripts/CMakeLists.txt ===
### This is just the absolute minimum script necessary
### to define a separate project that contains all the
### goodie scripts needed to support the biulding
### the ANTS tools

project(ANTSBuildScripts)
cmake_minimum_required(VERSION 2.8.5)

#install( FILES License.txt DESTINATION ${CMAKE_INSTALL_PREFIX} )

=== Examples/CMakeLists.txt ===
set(PICSL_INCLUDE_DIRS
../Utilities
../ImageRegistration
../ImageSegmentation
../GraphTheory
../Tensor
../Temporary
.
)

include_directories( ${BOOST_INCLUDE_DIR} ) #Define where to find Boost includes
include_directories(${PICSL_INCLUDE_DIRS})
link_directories( ${ITK_LIBRARY_PATH}  )
# message("${ITK_LIBRARIES}")
# non-templated class -- this should be stored in a library and linked in...
set(UI_SOURCES "../Utilities/antsCommandLineParser" "../Utilities/antsCommandLineOption" )

## Note that the antsUtilities can always be built static.  It will then be linked
## Directly into the other libraries.
add_library(antsUtilities STATIC antsUtilities.cxx ../Utilities/ReadWriteImage.cxx
		antsRegistrationTemplateHeader.cxx
	      	antsRegistration2DDouble.cxx
		antsRegistration3DDouble.cxx)
target_link_libraries(antsUtilities ${ITK_LIBRARIES} )

macro(STANDARD_ANTS_BUILD ANTS_FUNCTION_NAME EXTRA_LIBS)
  set( ANTS_FUNCTION_NAME ${ANTS_FUNCTION_NAME} )

  add_library(l_${ANTS_FUNCTION_NAME} ${ANTS_FUNCTION_NAME}.cxx ${UI_SOURCES})
  message(STATUS "${ANTS_FUNCTION_NAME} ${EXTRA_LIBS}")
  target_link_libraries(l_${ANTS_FUNCTION_NAME} antsUtilities ${ITK_LIBRARIES} ${EXTRA_LIBS} )
  configure_file( template_for_executables.cxx.in cli_${ANTS_FUNCTION_NAME}.cxx )
  add_executable( ${ANTS_FUNCTION_NAME} cli_${ANTS_FUNCTION_NAME}.cxx )
  target_link_libraries( ${ANTS_FUNCTION_NAME} l_${ANTS_FUNCTION_NAME})

  install(TARGETS l_${ANTS_FUNCTION_NAME} ${ANTS_FUNCTION_NAME}
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib
  )

endmacro()

#set(PROG_WITH_NO_FLAG simpleSynRegistration)
#add_executable(${PROG_WITH_NO_FLAG} ${PROG_WITH_NO_FLAG}.cxx)
#target_link_libraries(${PROG_WITH_NO_FLAG} antsUtilities ${ITK_LIBRARIES})

set(BASE_ANTS_APPS
  ANTS
  ANTSJacobian
  PrintHeader
  ResetDirection
  # ResetDirection2
  # BoykovGraphCutFilter
  # GeneralLinearModel
  ANTSUseLandmarkImagesToGetAffineTransform
  ANTSUseLandmarkImagesToGetBSplineDisplacementField
  ANTSUseDeformationFieldToGetAffineTransform
  # FDR
  antsAffineInitializer
  ImageMath
  SurfaceCurvature
  SurfaceBasedSmoothing
  # test
  # WarpImage
  LaplacianThickness
  SetOrigin
  SetSpacing
  SetDirectionByMatrix
  # WarpFunctionalImage
  ConvertScalarImageToRGB
  CreateWarpedGridImage
  # CreateJacobianDeterminantImage
  MeasureImageSimilarity
  ConvertToJpg
  ConvertImagePixelType
  AverageImages
  AverageTensorImages
  ImageSetStatistics
  ThresholdImage
  MultiplyImages
  SmoothImage
  ClusterImageStatistics
  LabelClustersUniquely
  # StudentsTestOnImages
  LabelOverlapMeasures
  MeasureMinMaxMean
  WarpImageMultiTransform
  ComposeMultiTransform
  StackSlices
  MemoryTest
  # ANTSOrientImage
  PermuteFlipImageOrientationAxes
  ImageCompare
  ResampleImageBySpacing
  # ResampleImageByOtherImage
  CopyImageHeaderInformation
  WarpTimeSeriesImageMultiTransform
  ResampleImage
  ExtractSliceFromImage
  ExtractRegionFromImage
  ExtractRegionFromImageByMask
  LabelGeometryMeasures
  PasteImageIntoImage
  TileImages
  CreateImage
  WarpTensorImageMultiTransform
  ReorientTensorImage
  RebaseTensorImage
  N3BiasFieldCorrection
  N4BiasFieldCorrection
  KellySlater
  KellyKapowski
  CreateDTICohort
  AverageAffineTransform
  AverageAffineTransformNoRigid
  antsAlignOrigin
  antsRegistration
  simpleSynRegistration
  antsApplyTransforms
  antsApplyTransformsToPoints
  CompositeTransformUtil
  antsMotionCorr
  sccan
  CreateDisplacementField
  ANTSIntegrateVectorField
  ANTSIntegrateVelocityField
  AtroposMin
  Atropos
  ConvertTransformFile
  compareTwoCompositeTransforms
  TimeSCCAN
)
foreach(ANTS_APP ${BASE_ANTS_APPS})
  STANDARD_ANTS_BUILD(${ANTS_APP} "")
endforeach()

if(USE_VTK)
include(${CMAKE_ROOT}/Modules/FindVTK.cmake)
if(USE_VTK_FILE)
  include(${USE_VTK_FILE})
set(VTK_ANTS_APPS
    ConvertVectorFieldToVTK
    GetMeshAndTopology
    CheckTopology
    WarpVTKPolyDataMultiTransform
    # FLATFEM
    # ConformalMapping
    # ANTSConformalMapping
  )
foreach(ANTS_APP ${VTK_ANTS_APPS})
  STANDARD_ANTS_BUILD(${ANTS_APP} "${VTK_LIBRARIES}")
endforeach()
endif(USE_VTK_FILE)
endif(USE_VTK)

install(PROGRAMS ../Scripts/ants.sh
                 ../Scripts/basic_ants_example.sh
                 ../Scripts/antsIntroduction.sh
                 ../Scripts/antsaffine.sh
                 ../Scripts/waitForXGridJobs.pl
                ../Scripts/buildtemplateparallel.sh
                 ../Scripts/ANTSpexec.sh
                 ../Scripts/waitForSGEQJobs.pl
                DESTINATION bin
                PERMISSIONS  OWNER_WRITE OWNER_READ OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
                CONFIGURATIONS  Release
        )


## Build test option
if(BUILD_TESTING)
    add_subdirectory(TestSuite)
endif(BUILD_TESTING)

# Copy all the shell scripts in the Scripts/ directory to the bin directory
##
option( COPY_SCRIPT_FILES_TO_BIN_DIR "Copy the script files to the ANTS bin directory." ON )
if( COPY_SCRIPT_FILES_TO_BIN_DIR )
  file( GLOB SCRIPT_FILES "${CMAKE_SOURCE_DIR}/../Scripts/*.sh" )
  file( GLOB PSCRIPT_FILES "${CMAKE_SOURCE_DIR}/../Scripts/*.pl" )
  foreach( SCRIPT_FILE ${SCRIPT_FILES} )
    add_custom_command( TARGET ANTS POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E copy ${SCRIPT_FILE} ${CMAKE_BINARY_DIR} )
  endforeach( SCRIPT_FILE )
  foreach( SCRIPT_FILE ${PSCRIPT_FILES} )
    add_custom_command( TARGET ANTS POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E copy ${SCRIPT_FILE} ${CMAKE_BINARY_DIR} )
  endforeach( SCRIPT_FILE )
endif( COPY_SCRIPT_FILES_TO_BIN_DIR )
set(CPACK_PACKAGE_NAME "ANTs")
set(CPACK_PACKAGE_VENDOR "CMake.org")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "ANTs - Advanced Normalization Tools")
set(CPACK_PACKAGE_VERSION "1.9.y")
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "9")
set(CPACK_PACKAGE_VERSION_PATCH "y")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "ANTS")
# This must always be last!
include(CPack)

=== Examples/TestSuite/CMakeLists.txt ===
###############################################################################
###############################################################################
## MakeTestDriverFromANTSbinary
## For tools made with the slicer execution model,
## This macro will build a test driver that adds the
## --compare
## --compareIntensityTolerance
## --compareRadiusTolerance
## --compareNumberOfPixelsTolerance
## to the SEM tools.
macro(MakeTestDriverFromANTSbinary ANTSbinaryName ANTSbinaryTestSourceName ANTS_FUNCTION_NAME)

  set(CMAKE_TESTDRIVER_BEFORE_TESTMAIN "#include \"itkTestDriverBeforeTest.inc\"")
  set(CMAKE_TESTDRIVER_AFTER_TESTMAIN "#include \"itkTestDriverAfterTest.inc\"")

  set(ANTS_FUNCTION_NAME ${ANTS_FUNCTION_NAME})
  configure_file( template_for_executableTestWrapper.cxx.in ${ANTSbinaryTestSourceName} )

  include_directories(${ITK_INCLUDE_DIRS})
  create_test_sourcelist(${ANTSbinaryName}   ${ANTSbinaryName}Driver.cxx ${ANTSbinaryTestSourceName}
     EXTRA_INCLUDE itkTestDriverIncludeRequiredIOFactories.h
     FUNCTION  ProcessArgumentsAndRegisterRequiredFactories
     )

  add_executable(${ANTSbinaryName}Driver ${ANTSbinaryName}Driver.cxx ${ANTSbinaryTestSourceName})
  target_link_libraries(${ANTSbinaryName}Driver l_${ANTS_FUNCTION_NAME} )
  set_target_properties(${ANTSbinaryName}Driver PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    LIBRARY_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    )
endmacro(MakeTestDriverFromANTSbinary ANTSbinaryName)

#-----------------------------------------------------------------------
# Setup locations to find externally maintained test data.
#-----------------------------------------------------------------------
include(ANTSExternalData)

# Tell ExternalData commands to transform raw files to content links.
set(ExternalData_LINK_CONTENT MD5)
set(ExternalData_SOURCE_ROOT ${${PROJECT_NAME}_SOURCE_DIR})
include(ExternalData)


# Set testing environment
set(ANTS_TEST_BIN_DIR ${CMAKE_BINARY_DIR}/Examples)

set(TEST_DATA_DIR ${CMAKE_SOURCE_DIR}/TestData)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/TEST_LOCATION)

## Test antsRegistration
##
file(GLOB_RECURSE INCS ${CMAKE_SOURCE_DIR}/Examples/"*.h")

MakeTestDriverFromANTSbinary(antsRegistrationTest antsRegistrationTest.cxx antsRegistration)
MakeTestDriverFromANTSbinary(ANTSTest ANTSTest.cxx ANTS)
MakeTestDriverFromANTSbinary(WarpImageMultiTransform WarpImageMultiTransformTest.cxx WarpImageMultiTransform)
MakeTestDriverFromANTSbinary(simpleSynRegistrationTest simpleSynRegistrationTest.cxx simpleSynRegistration)
MakeTestDriverFromANTSbinary(antsApplyTransformsTest antsApplyTransformsTest.cxx antsApplyTransforms)
MakeTestDriverFromANTSbinary(CompositeTransformUtilTest CompositeTransformUtilTest.cxx CompositeTransformUtil)
MakeTestDriverFromANTSbinary(compareTwoCompositeTransformsTest compareTwoCompositeTransformsTest.cxx compareTwoCompositeTransforms)



###
#  Perform testing
###
set(TestDataMD5_DIR ${CMAKE_SOURCE_DIR}/TestData)
set(SMALL_DATA_DIR ${TestDataMD5_DIR}/Data)

ExternalData_expand_arguments(${PROJECT_NAME}FetchData R16_IMAGE DATA{${SMALL_DATA_DIR}/r16slice.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData R64_IMAGE DATA{${SMALL_DATA_DIR}/r64slice.nii.gz})
###
# PSE sub-tests:  Check to see if .txt files and .vtk files also run correctly
###
ExternalData_expand_arguments(${PROJECT_NAME}FetchData DEVIL_IMAGE DATA{${SMALL_DATA_DIR}/Frown.nii})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData ANGEL_IMAGE DATA{${SMALL_DATA_DIR}/Smile.nii})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData DEVIL_IMAGE_TXT DATA{${SMALL_DATA_DIR}/Frown.txt})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData ANGEL_IMAGE_TXT DATA{${SMALL_DATA_DIR}/Smile.txt})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData DEVIL_IMAGE_VTK DATA{${SMALL_DATA_DIR}/Frown.vtk})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData ANGEL_IMAGE_VTK DATA{${SMALL_DATA_DIR}/Smile.vtk})
#ExternalData_expand_arguments(${PROJECT_NAME}FetchData SEG_IMAGE DATA{${SMALL_DATA_DIR}/nslice.nii.gz})

if(RUN_LONG_TESTS)

## A work around for the crazy ANTS command line that is not compatible
## with the testing framework of external tests

ExternalData_expand_arguments(${PROJECT_NAME}FetchData test_mask_VAR DATA{${TestDataMD5_DIR}/test_mask.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData scale_test_mask_VAR DATA{${TestDataMD5_DIR}/scale.test_mask.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData rotation_test_mask_VAR DATA{${TestDataMD5_DIR}/rotation.test_mask.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData translation_test_mask_VAR DATA{${TestDataMD5_DIR}/translation.test_mask.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData test_image_VAR DATA{${TestDataMD5_DIR}/test.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData scale_test_image_VAR DATA{${TestDataMD5_DIR}/scale.test.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData rotation_test_image_VAR DATA{${TestDataMD5_DIR}/rotation.test.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData rotation_geom_test_image_VAR DATA{${TestDataMD5_DIR}/rotation.geom.test.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData translation_test_image_VAR DATA{${TestDataMD5_DIR}/translation.test.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData translation_rescale_test_image_VAR DATA{${TestDataMD5_DIR}/translation.rescale.test.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData rotation_rescale_test_image_VAR DATA{${TestDataMD5_DIR}/rotation.rescale.test.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData ANON0006_20_T1_dbg_splayed_image_VAR DATA{${TestDataMD5_DIR}/ANON0006_20_T1_dbg_splayed.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData ANON0006_20_T1_sag_twisted_image_VAR DATA{${TestDataMD5_DIR}/ANON0006_20_T1_sag_twisted.nii.gz})

set(antsRegistrationTestName antsRegistrationTest_AffineScaleMasks)
ExternalData_add_test( ${PROJECT_NAME}FetchData NAME ${antsRegistrationTestName}
  COMMAND ${LAUNCH_EXE} $<TARGET_FILE:antsRegistrationTestDriver>
  --compare DATA{${TestDataMD5_DIR}/${antsRegistrationTestName}.result.nii.gz}
            ${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz
  --compareIntensityTolerance 9
  --compareRadiusTolerance 0
  --compareNumberOfPixelsTolerance 1000

  antsRegistrationTest
  --dimensionality 3
  --convergence 25x20x5 #numberOfIterations 2500
  --shrink-factors 1x1x1
  --smoothing-sigmas 0.1x0.1x0.1
  --metric Mattes[${test_image_VAR},${scale_test_image_VAR},1,200,Regular,0.10] #costMetric & fixedVolume & movingVolume & metricWeight? & numberOfHistogramBins & samplingStrategy? & samplingPercentage(numberOfSamples)
  --transform "Affine[0.001]" #transformType & minimumStepLength
  --initial-moving-transform DATA{${TestDataMD5_DIR}/Initializer_0.05_${antsRegistrationTestName}.mat}
  --masks[${test_mask_VAR},${scale_test_mask_VAR}] #fixedBinaryVolume & movingBinaryVolume
  --output [${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName},${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz,${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}_inverse.test.nii.gz]
)

set(antsRegistrationTestName antsRegistrationTest_AffineScaleNoMasks)
ExternalData_add_test( ${PROJECT_NAME}FetchData NAME ${antsRegistrationTestName}
  COMMAND ${LAUNCH_EXE} $<TARGET_FILE:antsRegistrationTestDriver>
  --compare DATA{${TestDataMD5_DIR}/${antsRegistrationTestName}.result.nii.gz}
            ${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz
  --compareIntensityTolerance 9
  --compareRadiusTolerance 0
  --compareNumberOfPixelsTolerance 1000

  antsRegistrationTest
  --dimensionality 3
  --convergence 25x20x5
  --shrink-factors 1x1x1
  --smoothing-sigmas 0.1x0.1x0.1
  -u
  --metric Mattes[${test_image_VAR},${scale_test_image_VAR},1,200,Regular,0.10]
  --transform "Affine[0.001]" #transformType & minimumStepLength
  --initial-moving-transform DATA{${TestDataMD5_DIR}/Initializer_0.05_antsRegistrationTest_AffineScaleMasks.mat}
  --output [${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName},${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz]
)

set(antsRegistrationTestName antsRegistrationTest_AffineRotationMasks)
ExternalData_add_test( ${PROJECT_NAME}FetchData NAME ${antsRegistrationTestName}
  COMMAND ${LAUNCH_EXE} $<TARGET_FILE:antsRegistrationTestDriver>
  --compare DATA{${TestDataMD5_DIR}/${antsRegistrationTestName}.result.nii.gz}
            ${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz
  --compareIntensityTolerance 7
  --compareRadiusTolerance 0
  --compareNumberOfPixelsTolerance 777

  antsRegistrationTest
  --dimensionality 3
  --convergence 25x20x5
  --shrink-factors 1x1x1
  --smoothing-sigmas 0.1x0.1x0.1
  --metric Mattes[${test_image_VAR},${rotation_test_image_VAR},1,200,Regular,0.10]
  --transform "Affine[0.001]"
  --initial-moving-transform DATA{${TestDataMD5_DIR}/Initializer_0.05_${antsRegistrationTestName}.mat}
  --masks[${test_mask_VAR},${rotation_test_mask_VAR}]
  --output [${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName},${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz]
)

set(antsRegistrationTestName antsRegistrationTest_AffineRotationNoMasks)
ExternalData_add_test( ${PROJECT_NAME}FetchData NAME ${antsRegistrationTestName}
  COMMAND ${LAUNCH_EXE} $<TARGET_FILE:antsRegistrationTestDriver>
  --compare DATA{${TestDataMD5_DIR}/${antsRegistrationTestName}.result.nii.gz}
            ${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz
  --compareIntensityTolerance 7
  --compareRadiusTolerance 0
  --compareNumberOfPixelsTolerance 777

  antsRegistrationTest
  --dimensionality 3
  --convergence 25x20x5
  --shrink-factors 1x1x1
  --smoothing-sigmas 0.1x0.1x0.1
  --metric Mattes[${test_image_VAR},${rotation_test_image_VAR},1,200,Regular,0.10]
  --transform "Affine[0.001]"
  --initial-moving-transform DATA{${TestDataMD5_DIR}/Initializer_0.05_${antsRegistrationTestName}.mat}
  --output [${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName},${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz]
)

set(antsRegistrationTestName antsRegistrationTest_AffineTranslationMasks)
ExternalData_add_test( ${PROJECT_NAME}FetchData NAME ${antsRegistrationTestName}
  COMMAND ${LAUNCH_EXE} $<TARGET_FILE:antsRegistrationTestDriver>
  --compare DATA{${TestDataMD5_DIR}/${antsRegistrationTestName}.result.nii.gz}
            ${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz
  --compareIntensityTolerance 7
  --compareRadiusTolerance 0
  --compareNumberOfPixelsTolerance 777

  antsRegistrationTest
  --dimensionality 3
  --convergence 25x20x5
  --shrink-factors 1x1x1
  --smoothing-sigmas 0.1x0.1x0.1
  --metric MeanSquares[${test_image_VAR},${translation_test_image_VAR},1,radius=NA,Regular,0.10]
  --transform "Affine[0.001]"
  --initial-moving-transform DATA{${TestDataMD5_DIR}/Initializer_${antsRegistrationTestName}.mat}
  --masks[${test_mask_VAR},${translation_test_mask_VAR}]
  --output [${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName},${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz]
)

set(antsRegistrationTestName antsRegistrationTest_AffineTranslationNoMasks)
ExternalData_add_test( ${PROJECT_NAME}FetchData NAME ${antsRegistrationTestName}
  COMMAND ${LAUNCH_EXE} $<TARGET_FILE:antsRegistrationTestDriver>
  --compare DATA{${TestDataMD5_DIR}/${antsRegistrationTestName}.result.nii.gz}
            ${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz
  --compareIntensityTolerance 7
  --compareRadiusTolerance 0
  --compareNumberOfPixelsTolerance 777

  antsRegistrationTest
  --dimensionality 3
  --convergence 25x20x5
  --shrink-factors 1x1x1
  --smoothing-sigmas 0.1x0.1x0.1

=== debian/changelog ===
ants (2.0.0-1~nd70+1) wheezy; urgency=low

  * Backported for wheezy.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Fri, 28 Feb 2014 12:03:58 -0500

ants (2.0.0-1) unstable; urgency=low

  [Gert Wollny]
  * Move to debhelper 9
  * Add the test data to the debian subdir
  * add soversion and version to the shared libraries 
  
  [Yaroslav Halchenko]
  * Fresh upstream release
  * debian/control
    - build-depends: switch to ITK4, add libboost-dev, remove libgdcm2-dev
      (Closes: #731923), add libtiff-dev, libdcmtk2-dev
    - boost policy compliance to 3.9.5
  * debian/copyright
    - update for Dep5
  * debian/patches
    - drop patch in favor of in-installation sed-adjustment of default
      ANTSPATHs
    - up_use_bash -- use bash not just sh in scripts (Closes: #690622)
  * debian/rules
    - add sinking http{,s}_proxy to avoid online acquisition
    - adjust cmake options to run short tests, build shared libs, use system
      ITK
    - various tune ups (rpath, do not run tests on slow boxes, etc)
  * debian/{rules,control}
    - install a versioned Modulesfile for ants, and recommend
      environment-modules

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 11 Dec 2013 13:02:20 -0500

=== debian/control ===
Source: ants
Section: science
Priority: extra
Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
X-Original-Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
Build-Depends: debhelper (>= 9),
               help2man, cmake,
               libopenjpeg-dev, libinsighttoolkit4-dev, libvtk5-dev, uuid-dev,
               tcl-vtk | libvtk5-dev (<< 5.8),
               python-vtk | libvtk5-dev (<< 5.8),
               libvtk-java | libvtk5-dev (<< 5.8),
               libvtk5.8-qt4 | libvtk5-dev (<< 5.8),
               libboost-dev,
               libtiff-dev,
               libdcmtk2-dev,
Standards-Version: 3.9.5
Homepage: http://www.picsl.upenn.edu/ANTS/
Vcs-Git: git://git.debian.org/pkg-exppsy/ants.git
Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/ants.git;a=summary

Package: ants
Architecture: any
Depends: neurodebian-popularity-contest, ${shlibs:Depends}, ${misc:Depends}
Recommends: environment-modules
Suggests: fsl, gridengine-client, r-base-core 
Description: advanced normalization tools for brain and image analysis
 Advanced Normalization Tools (ANTS) is an ITK-based suite of
 normalization, segmentation and template-building tools for
 quantitative morphometric analysis. Many of the ANTS registration
 tools are diffeomorphic, but deformation (elastic and BSpline)
 transformations are available. Unique components of ANTS include
 multivariate similarity metrics, landmark guidance, the ability to
 use label images to guide the mapping and both greedy and space-time
 optimal implementations of diffeomorphisms. The symmetric
 normalization (SyN) strategy is a part of the ANTS toolkit as is
 directly manipulated free form deformation (DMFFD).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

srcpkg = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Source:' | cut -d ' ' -f 2,2)
debver = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Version:' | cut -d ' ' -f 2,2 )
uver = $(shell echo $(debver) | cut -d '-' -f 1,1 )

modulesfile = debian/ants.environment-modules

export  http_proxy=http://127.0.0.1:9/
export  https_proxy=http://127.0.0.1:9/

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
    export CFLAGS += -O0
else
    export CFLAGS += -O2
endif

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# Exclude all heavy tests while building on slowish build
# bots/platforms
CTEST_EXCLUDE = $(shell [ `grep -i bogomips /proc/cpuinfo | head -n 1 | sed -e 's,.*:\s*\([0-9]*\)\(\..*\)*$,\1,g'` -gt 2000 ] || echo "-E '^ANTS(_|PSE)'")

# Default mega-rule
%:
	dh $@ --parallel


override_dh_auto_configure:
	dh_auto_configure -- \
		-DANTS_SUPERBUILD:BOOL=OFF \
		-DANTS_USE_GIT_PROTOC:BOOL=OFF \
		-DCOPY_SCRIPT_FILES_TO_BIN_DIR:BOOL=OFF \
		-DCMAKE_SKIP_RPATH:BOOL=OFF \
		-DUSE_SYSTEM_ITK:BOOL=ON \
		-DUSE_VTK:BOOL=ON \
		-DBUILD_SHARED_LIBS:BOOL=ON \
		-DRUN_SHORT_TESTS:BOOL=ON \
		-DRUN_LONG_TESTS:BOOL=OFF \
		-DEXECUTABLE_OUTPUT_PATH:PATH=$(DESTBINDIR) \
		--debug-output

%modules: %modules.in
	sed -e 's,$$UVERSION,$(uver),g' $< >| $@

override_dh_auto_build: $(modulesfile)
	dh_auto_build
	: Build manpages
	cd `/bin/ls -d obj-*/bin` && mkdir -p ../man && \
    for f in *; do \
	 help2man --name="part of ANTS registration suite" --version-string $(uver) \
	          --no-info --no-discard-stderr ./$$f >| ../man/$$f.1; \
     done


override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd obj-*
	ln -s debian/testdata ExternalData
	ctest --force-new-ctest-process $(CTEST_EXCLUDE)
else
	: # Skip unittests due to nocheck
endif

override_dh_auto_install:
	dh_auto_install
	: remove .so files 
	rm debian/ants/usr/lib/*.so
	: Move binaries under usr/lib/ants
	mv debian/ants/usr/bin/* debian/ants/usr/lib/ants
	: Symlink binaries of primary importance into /usr/bin
	for f in ANTS WarpImageMultiTransform; do \
		dh_link usr/lib/ants/$$f usr/bin/$$f; \
	done
	: Install shell scripts
	install -t debian/ants/usr/lib/ants Scripts/*
	: Install modules file
	install -m 664 -t debian/ants/usr/share/modules/modulefiles/ants $(modulesfile)
	: Adjust ANTSPATH
	cd debian/ants/usr/lib/ants && sed -ie 's,\([^"=]*\(/bin/ants\|ANTS/release/bin\)\),/usr/lib/ants,g' *.sh *.pl && rm *.she *.ple
	: Install manpages
	dh_installman obj-*/man/*

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDDIR) debian/ants.environment-modules

# upstream tests use some tiny dataset for tests, which
# they deposited online instead of keeping under the GIT
# Since the data size is small, we just package it along,
# but that would require first building ANTs
get_upstream_external_data:
	mkdir -p .ExternalData/MD5
	# TODO

## ants 2.1.0~rc2+git3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,8 @@
 cmake_minimum_required(VERSION 2.8.5)
 cmake_policy(VERSION 2.8.5)
+
+set(LIBRARY_SOVERSION_INFO 2)
+set(LIBRARY_VERSION_INFO 2.1.0)
 
 set(LOCAL_PROJECT_NAME ANTS)
 INCLUDE(InstallRequiredSystemLibraries)
@@ -31,9 +34,9 @@
 set(CPACK_PACKAGE_NAME "ANTs")
 set(CPACK_PACKAGE_VENDOR "CMake.org")
 set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "ANTs - Advanced Normalization Tools")
-set(CPACK_PACKAGE_VERSION "1.9.v4")
-set(CPACK_PACKAGE_VERSION_MAJOR "1")
-set(CPACK_PACKAGE_VERSION_MINOR "9")
+set(CPACK_PACKAGE_VERSION "2.1.v4")
+set(CPACK_PACKAGE_VERSION_MAJOR "2")
+set(CPACK_PACKAGE_VERSION_MINOR "1")
 set(CPACK_PACKAGE_VERSION_PATCH "v4")
 set(CPACK_PACKAGE_INSTALL_DIRECTORY "ANTS_Install")
 set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.txt")

=== Examples/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 ../Temporary
 .
 )
-
+	
 include_directories( ${BOOST_INCLUDE_DIR} ) #Define where to find Boost includes
 include_directories(${PICSL_INCLUDE_DIRS})
 link_directories( ${ITK_LIBRARY_PATH}  )
@@ -17,16 +17,18 @@
 
 ## Note that the antsUtilities can always be built static.  It will then be linked
 ## Directly into the other libraries.
-add_library(antsUtilities STATIC antsUtilities.cxx ../Utilities/ReadWriteImage.cxx
-		antsRegistrationTemplateHeader.cxx
-	      	antsRegistration2DDouble.cxx
-		antsRegistration3DDouble.cxx)
+add_library(antsUtilities STATIC antsUtilities.cxx ../Utilities/ReadWriteData.cxx
+            antsRegistrationTemplateHeader.cxx
+            antsRegistration2DDouble.cxx antsRegistration2DFloat.cxx
+            antsRegistration3DDouble.cxx antsRegistration3DFloat.cxx)
 target_link_libraries(antsUtilities ${ITK_LIBRARIES} )
 
 macro(STANDARD_ANTS_BUILD ANTS_FUNCTION_NAME EXTRA_LIBS)
   set( ANTS_FUNCTION_NAME ${ANTS_FUNCTION_NAME} )
 
   add_library(l_${ANTS_FUNCTION_NAME} ${ANTS_FUNCTION_NAME}.cxx ${UI_SOURCES})
+  SET_TARGET_PROPERTIES(l_${ANTS_FUNCTION_NAME} PROPERTIES 
+    SOVERSION ${LIBRARY_SOVERSION_INFO}  VERSION ${LIBRARY_VERSION_INFO})
   message(STATUS "${ANTS_FUNCTION_NAME} ${EXTRA_LIBS}")
   target_link_libraries(l_${ANTS_FUNCTION_NAME} antsUtilities ${ITK_LIBRARIES} ${EXTRA_LIBS} )
   configure_file( template_for_executables.cxx.in cli_${ANTS_FUNCTION_NAME}.cxx )
@@ -70,10 +72,11 @@
   # WarpFunctionalImage
   ConvertScalarImageToRGB
   CreateWarpedGridImage
-  # CreateJacobianDeterminantImage
+  CreateJacobianDeterminantImage
   MeasureImageSimilarity
   ConvertToJpg
   ConvertImagePixelType
+  ConvertInputImagePixelTypeToFloat
   AverageImages
   AverageTensorImages
   ImageSetStatistics
@@ -103,6 +106,7 @@
   LabelGeometryMeasures
   PasteImageIntoImage
   TileImages
+  CreateTiledMosaic
   CreateImage
   WarpTensorImageMultiTransform
   ReorientTensorImage
@@ -121,37 +125,40 @@
   antsApplyTransformsToPoints
   CompositeTransformUtil
   antsMotionCorr
+  antsMotionCorrStats
+  antsMotionCorrDiffusionDirection
   sccan
   CreateDisplacementField
   ANTSIntegrateVectorField
   ANTSIntegrateVelocityField
-  AtroposMin
   Atropos
   ConvertTransformFile
   compareTwoCompositeTransforms
   TimeSCCAN
+  GetConnectedComponentsFeatureImages
+  DeNrrd
 )
 foreach(ANTS_APP ${BASE_ANTS_APPS})
   STANDARD_ANTS_BUILD(${ANTS_APP} "")
 endforeach()
 
 if(USE_VTK)
-include(${CMAKE_ROOT}/Modules/FindVTK.cmake)
-if(USE_VTK_FILE)
-  include(${USE_VTK_FILE})
+find_package(VTK REQUIRED NO_MODULE)
+include(${VTK_USE_FILE})
 set(VTK_ANTS_APPS
-    ConvertVectorFieldToVTK
-    GetMeshAndTopology
-    CheckTopology
-    WarpVTKPolyDataMultiTransform
+#    ConvertVectorFieldToVTK
+    antsSurf
+    # GetMeshAndTopology
+    # CheckTopology
+    # WarpVTKPolyDataMultiTransform
     # FLATFEM
     # ConformalMapping
     # ANTSConformalMapping
   )
+
 foreach(ANTS_APP ${VTK_ANTS_APPS})
   STANDARD_ANTS_BUILD(${ANTS_APP} "${VTK_LIBRARIES}")
 endforeach()
-endif(USE_VTK_FILE)
 endif(USE_VTK)
 
 install(PROGRAMS ../Scripts/ants.sh

=== ExternalApplications/CMakeLists.txt ===
#This helps organize the external applicaitons

add_subdirectory(MALF)

=== ExternalApplications/MALF/CMakeLists.txt ===
## This work is described in detail in http://dx.doi.org/10.1109/TPAMI.2012.143

## ========= Reference text that can be used to describe these methods
#Multi-atlas label fusion is a segmentation strategy that has been applied to a number of medical image segmentation problems. The method makes use of a set of expert-labeled atlases, where each atlas consists of a sample image and a set of labels for the anatomic structures in that image.  When a new target image is presented for segmentation, each atlas image is registered to the target image.  The deformation fields obtained by registration are then used to propagate the atlas labels to the target image.  Depending on dissimilarities in anatomy and appearance between the atlas and target images, each atlas produces a different segmentation of the target image.  Multi-atlas label fusion combines these results to produce a consensus segmentation of the target image.  
#
#Joint label fusion is an extension of multi-atlas label fusion that aims to reduce segmentation bias produced by redundancies in the atlas set. To capture the redundancies, the method accounts for both similarity between each atlas and the target as well as similarity between atlases for label fusion. The expected label error produced by one atlas is large when the image intensity difference between the warped atlas and target image is large. The expectation that any two atlases both produce a label error is large only when the two atlases are similar and both have large intensity differences from the target image. Given the estimated pairwise atlas correlations, joint label fusion computes spatially-varying voting weights for each atlas in a closed form. The final consensus segmentation is produced by weighted voting.    

project(PICSL_MALF)

add_executable(jointfusion ./JointFusion/LabelFusion.cxx)
add_executable(sa ./CorrectiveLearning/segAdapter.cxx)
add_executable(bl ./CorrectiveLearning/BiasLearn.cxx)

target_link_libraries(jointfusion ${ITK_LIBRARIES} )
target_link_libraries(sa ${ITK_LIBRARIES} )
target_link_libraries(bl ${ITK_LIBRARIES} )


install(TARGETS jointfusion sa bl
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib)

## ants 2.1.0~rc2+git3-g9103999

=== debian/changelog ===
ants (2.1.0~rc2+git3-g9103999-4) unstable; urgency=medium

  * patches/up_lower_cc_3_test_i386_precision
    - lower precision for the ANTS_CC_3_WARP_METRIC_0 test to mitigate
      FTBFS on i386 (Closes: #768645)

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 21 Nov 2014 15:35:44 -0500

ants (2.1.0~rc2+git3-g9103999-3) unstable; urgency=medium

  * Added Conflicts for gpe-conf also providing bl.1.gz manpage
    (gpe-conf is for embedded systems, so unlikely to be co-installed with
    ants in production) (Closes: #768222)
  * patches/up_Rscript
    - prepend Rscript call with /usr/bin/env

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 05 Nov 2014 21:27:30 -0500

ants (2.1.0~rc2+git3-g9103999-2) unstable; urgency=medium

  * Robustify bogomips comparison, fix tests execution

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 18 Aug 2014 16:41:04 -0400

ants (2.1.0~rc2+git3-g9103999-1) unstable; urgency=medium

  * Newer upstream pre-release
    - should be compatible with ITK v4.6.0 and VTK 6.1 (Closes: #757595)
    - explicitly include libhdf5-dev into build-depends to mitigate
      problem with insufficient depends of ITK -dev (see #757594)
  * debian/patches
    - removed debian/patches/up_use_bash (upstreamed)
    - Add-soname-and-local-data.patch -> deb_local-data.patch
      (SONAME and SOVERSIONing is done now by upstream)
  * debian/{control,rules}
    - build without VTK support for now
    - added libpng12-dev to build-depends
  * debian/rules
    - fixed up installation of versioned ants modulefile

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 13 Aug 2014 12:12:07 -0400

ants (2.0.0-2) unstable; urgency=medium

  * debian/control
    - added libfftw3-dev to build-depends explicitly (Closes: #747954)

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 13 May 2014 09:02:43 -0400

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,11 @@
 Source: ants
 Section: science
 Priority: extra
-Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
-X-Original-Maintainer: NeuroDebian Team <team@neuro.debian.net>
+Maintainer: NeuroDebian Team <team@neuro.debian.net>
 Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
 Build-Depends: debhelper (>= 9),
                help2man, cmake,
-               libopenjpeg-dev, libinsighttoolkit4-dev, libvtk5-dev, uuid-dev,
+               libopenjpeg-dev, libinsighttoolkit4-dev, uuid-dev,
                tcl-vtk | libvtk5-dev (<< 5.8),
                python-vtk | libvtk5-dev (<< 5.8),
                libvtk-java | libvtk5-dev (<< 5.8),
@@ -14,6 +13,9 @@
                libboost-dev,
                libtiff-dev,
                libdcmtk2-dev,
+               libfftw3-dev,
+               libhdf5-dev,
+               libpng12-dev,
 Standards-Version: 3.9.5
 Homepage: http://www.picsl.upenn.edu/ANTS/
 Vcs-Git: git://git.debian.org/pkg-exppsy/ants.git
@@ -21,9 +23,10 @@
 
 Package: ants
 Architecture: any
-Depends: neurodebian-popularity-contest, ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Conflicts: gpe-conf
 Recommends: environment-modules
-Suggests: fsl, gridengine-client, r-base-core 
+Suggests: fsl, gridengine-client, r-base-core
 Description: advanced normalization tools for brain and image analysis
  Advanced Normalization Tools (ANTS) is an ITK-based suite of
  normalization, segmentation and template-building tools for
@@ -35,3 +38,6 @@
  optimal implementations of diffeomorphisms. The symmetric
  normalization (SyN) strategy is a part of the ANTS toolkit as is
  directly manipulated free form deformation (DMFFD).
+ .
+ This package provides environment-modules configuration.
+ Use 'module load ants' to make all cmdline tools available in your shell.

=== debian/rules ===
--- 
+++ 
@@ -23,7 +23,8 @@
 
 # Exclude all heavy tests while building on slowish build
 # bots/platforms
-CTEST_EXCLUDE = $(shell [ `grep -i bogomips /proc/cpuinfo | head -n 1 | sed -e 's,.*:\s*\([0-9]*\)\(\..*\)*$,\1,g'` -gt 2000 ] || echo "-E '^ANTS(_|PSE)'")
+BOGOMIPS = $(shell awk '/^bogomips/{print $$3;}' /proc/cpuinfo | sed -ne '1s,\..*,,gp' )
+CTEST_EXCLUDE = $(shell [ "$(BOGOMIPS)" -gt 2000 ] || echo "-E '^ANTS(_|PSE)'")
 
 # Default mega-rule
 %:
@@ -37,7 +38,7 @@
 		-DCOPY_SCRIPT_FILES_TO_BIN_DIR:BOOL=OFF \
 		-DCMAKE_SKIP_RPATH:BOOL=OFF \
 		-DUSE_SYSTEM_ITK:BOOL=ON \
-		-DUSE_VTK:BOOL=ON \
+		-DUSE_VTK:BOOL=OFF \
 		-DBUILD_SHARED_LIBS:BOOL=ON \
 		-DRUN_SHORT_TESTS:BOOL=ON \
 		-DRUN_LONG_TESTS:BOOL=OFF \
@@ -59,9 +60,9 @@
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	cd obj-*
-	ln -s debian/testdata ExternalData
-	ctest --force-new-ctest-process $(CTEST_EXCLUDE)
+	cd obj-*; \
+	 ln -s ../debian/testdata ExternalData || : ; \
+	 ctest --force-new-ctest-process $(CTEST_EXCLUDE)
 else
 	: # Skip unittests due to nocheck
 endif
@@ -79,7 +80,7 @@
 	: Install shell scripts
 	install -t debian/ants/usr/lib/ants Scripts/*
 	: Install modules file
-	install -m 664 -t debian/ants/usr/share/modules/modulefiles/ants $(modulesfile)
+	install -m 664 $(modulesfile) debian/ants/usr/share/modules/modulefiles/ants/$(uver)
 	: Adjust ANTSPATH
 	cd debian/ants/usr/lib/ants && sed -ie 's,\([^"=]*\(/bin/ants\|ANTS/release/bin\)\),/usr/lib/ants,g' *.sh *.pl && rm *.she *.ple
 	: Install manpages
